# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::KeyVault::Mgmt::V2018_02_14_preview
  module Models
    #
    # Properties of the secret
    #
    class SecretProperties

      include MsRestAzure

      # @return [String] The value of the secret. NOTE: 'value' will never be
      # returned from the service, as APIs using this model are is intended for
      # internal use in ARM deployments. Users should use the data-plane REST
      # service for interaction with vault secrets.
      attr_accessor :value

      # @return [String] The content type of the secret.
      attr_accessor :content_type

      # @return [SecretAttributes] The attributes of the secret.
      attr_accessor :attributes

      # @return [String] The URI to retrieve the current version of the secret.
      attr_accessor :secret_uri

      # @return [String] The URI to retrieve the specific version of the
      # secret.
      attr_accessor :secret_uri_with_version


      #
      # Mapper for SecretProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'SecretProperties',
          type: {
            name: 'Composite',
            class_name: 'SecretProperties',
            model_properties: {
              value: {
                client_side_validation: true,
                required: false,
                serialized_name: 'value',
                type: {
                  name: 'String'
                }
              },
              content_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'contentType',
                type: {
                  name: 'String'
                }
              },
              attributes: {
                client_side_validation: true,
                required: false,
                serialized_name: 'attributes',
                type: {
                  name: 'Composite',
                  class_name: 'SecretAttributes'
                }
              },
              secret_uri: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'secretUri',
                type: {
                  name: 'String'
                }
              },
              secret_uri_with_version: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'secretUriWithVersion',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
