# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::KeyVault::Mgmt::V2019_09_01
  module Models
    #
    # The object attributes managed by the Azure Key Vault service.
    #
    class Attributes

      include MsRestAzure

      # @return [Boolean] Determines whether or not the object is enabled.
      attr_accessor :enabled

      # @return [Integer] Not before date in seconds since
      # 1970-01-01T00:00:00Z.
      attr_accessor :not_before

      # @return [Integer] Expiry date in seconds since 1970-01-01T00:00:00Z.
      attr_accessor :expires

      # @return [Integer] Creation time in seconds since 1970-01-01T00:00:00Z.
      attr_accessor :created

      # @return [Integer] Last updated time in seconds since
      # 1970-01-01T00:00:00Z.
      attr_accessor :updated

      # @return [DeletionRecoveryLevel] The deletion recovery level currently
      # in effect for the object. If it contains 'Purgeable', then the object
      # can be permanently deleted by a privileged user; otherwise, only the
      # system can purge the object at the end of the retention interval.
      # Possible values include: 'Purgeable', 'Recoverable+Purgeable',
      # 'Recoverable', 'Recoverable+ProtectedSubscription'
      attr_accessor :recovery_level


      #
      # Mapper for Attributes class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Attributes',
          type: {
            name: 'Composite',
            class_name: 'Attributes',
            model_properties: {
              enabled: {
                client_side_validation: true,
                required: false,
                serialized_name: 'enabled',
                type: {
                  name: 'Boolean'
                }
              },
              not_before: {
                client_side_validation: true,
                required: false,
                serialized_name: 'nbf',
                type: {
                  name: 'Number'
                }
              },
              expires: {
                client_side_validation: true,
                required: false,
                serialized_name: 'exp',
                type: {
                  name: 'Number'
                }
              },
              created: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'created',
                type: {
                  name: 'Number'
                }
              },
              updated: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'updated',
                type: {
                  name: 'Number'
                }
              },
              recovery_level: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'recoveryLevel',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
