# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Resources::Mgmt::V2016_07_01
  module Models
    #
    # Deployment properties.
    #
    class DeploymentProperties

      include MsRestAzure

      # @return The template content. It can be a JObject or a well formed JSON
      # string. Use only one of Template or TemplateLink.
      attr_accessor :template

      # @return [TemplateLink] The template URI. Use only one of Template or
      # TemplateLink.
      attr_accessor :template_link

      # @return Deployment parameters. It can be a JObject or a well formed
      # JSON string. Use only one of Parameters or ParametersLink.
      attr_accessor :parameters

      # @return [ParametersLink] The parameters URI. Use only one of Parameters
      # or ParametersLink.
      attr_accessor :parameters_link

      # @return [DeploymentMode] The deployment mode. Possible values include:
      # 'Incremental', 'Complete'
      attr_accessor :mode

      # @return [DebugSetting] The debug setting of the deployment.
      attr_accessor :debug_setting


      #
      # Mapper for DeploymentProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'DeploymentProperties',
          type: {
            name: 'Composite',
            class_name: 'DeploymentProperties',
            model_properties: {
              template: {
                client_side_validation: true,
                required: false,
                serialized_name: 'template',
                type: {
                  name: 'Object'
                }
              },
              template_link: {
                client_side_validation: true,
                required: false,
                serialized_name: 'templateLink',
                type: {
                  name: 'Composite',
                  class_name: 'TemplateLink'
                }
              },
              parameters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'parameters',
                type: {
                  name: 'Object'
                }
              },
              parameters_link: {
                client_side_validation: true,
                required: false,
                serialized_name: 'parametersLink',
                type: {
                  name: 'Composite',
                  class_name: 'ParametersLink'
                }
              },
              mode: {
                client_side_validation: true,
                required: true,
                serialized_name: 'mode',
                type: {
                  name: 'Enum',
                  module: 'DeploymentMode'
                }
              },
              debug_setting: {
                client_side_validation: true,
                required: false,
                serialized_name: 'debugSetting',
                type: {
                  name: 'Composite',
                  class_name: 'DebugSetting'
                }
              }
            }
          }
        }
      end
    end
  end
end
