# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Resources::Mgmt::V2020_06_01
  module Models
    #
    # The alias type.
    #
    class AliasModel

      include MsRestAzure

      # @return [String] The alias name.
      attr_accessor :name

      # @return [Array<AliasPath>] The paths for an alias.
      attr_accessor :paths

      # @return [AliasType] The type of the alias. Possible values include:
      # 'NotSpecified', 'PlainText', 'Mask'
      attr_accessor :type

      # @return [String] The default path for an alias.
      attr_accessor :default_path

      # @return [AliasPattern] The default pattern for an alias.
      attr_accessor :default_pattern

      # @return [AliasPathMetadata] The default alias path metadata. Applies to
      # the default path and to any alias path that doesn't have metadata
      attr_accessor :default_metadata


      #
      # Mapper for AliasModel class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Alias',
          type: {
            name: 'Composite',
            class_name: 'AliasModel',
            model_properties: {
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              paths: {
                client_side_validation: true,
                required: false,
                serialized_name: 'paths',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'AliasPathElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'AliasPath'
                      }
                  }
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'type',
                type: {
                  name: 'Enum',
                  module: 'AliasType'
                }
              },
              default_path: {
                client_side_validation: true,
                required: false,
                serialized_name: 'defaultPath',
                type: {
                  name: 'String'
                }
              },
              default_pattern: {
                client_side_validation: true,
                required: false,
                serialized_name: 'defaultPattern',
                type: {
                  name: 'Composite',
                  class_name: 'AliasPattern'
                }
              },
              default_metadata: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'defaultMetadata',
                type: {
                  name: 'Composite',
                  class_name: 'AliasPathMetadata'
                }
              }
            }
          }
        }
      end
    end
  end
end
