# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Resources::Mgmt::V2020_06_01
  module Models
    #
    # Deployment properties with additional details.
    #
    class DeploymentPropertiesExtended

      include MsRestAzure

      # @return [ProvisioningState] Denotes the state of provisioning. Possible
      # values include: 'NotSpecified', 'Accepted', 'Running', 'Ready',
      # 'Creating', 'Created', 'Deleting', 'Deleted', 'Canceled', 'Failed',
      # 'Succeeded', 'Updating'
      attr_accessor :provisioning_state

      # @return [String] The correlation ID of the deployment.
      attr_accessor :correlation_id

      # @return [DateTime] The timestamp of the template deployment.
      attr_accessor :timestamp

      # @return [String] The duration of the template deployment.
      attr_accessor :duration

      # @return Key/value pairs that represent deployment output.
      attr_accessor :outputs

      # @return [Array<Provider>] The list of resource providers needed for the
      # deployment.
      attr_accessor :providers

      # @return [Array<Dependency>] The list of deployment dependencies.
      attr_accessor :dependencies

      # @return [TemplateLink] The URI referencing the template.
      attr_accessor :template_link

      # @return Deployment parameters.
      attr_accessor :parameters

      # @return [ParametersLink] The URI referencing the parameters.
      attr_accessor :parameters_link

      # @return [DeploymentMode] The deployment mode. Possible values are
      # Incremental and Complete. Possible values include: 'Incremental',
      # 'Complete'
      attr_accessor :mode

      # @return [DebugSetting] The debug setting of the deployment.
      attr_accessor :debug_setting

      # @return [OnErrorDeploymentExtended] The deployment on error behavior.
      attr_accessor :on_error_deployment

      # @return [String] The hash produced for the template.
      attr_accessor :template_hash

      # @return [Array<ResourceReference>] Array of provisioned resources.
      attr_accessor :output_resources

      # @return [Array<ResourceReference>] Array of validated resources.
      attr_accessor :validated_resources

      # @return [ErrorResponse] The deployment error.
      attr_accessor :error


      #
      # Mapper for DeploymentPropertiesExtended class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'DeploymentPropertiesExtended',
          type: {
            name: 'Composite',
            class_name: 'DeploymentPropertiesExtended',
            model_properties: {
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'provisioningState',
                type: {
                  name: 'String'
                }
              },
              correlation_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'correlationId',
                type: {
                  name: 'String'
                }
              },
              timestamp: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'timestamp',
                type: {
                  name: 'DateTime'
                }
              },
              duration: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'duration',
                type: {
                  name: 'String'
                }
              },
              outputs: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'outputs',
                type: {
                  name: 'Object'
                }
              },
              providers: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'providers',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ProviderElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'Provider'
                      }
                  }
                }
              },
              dependencies: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'dependencies',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'DependencyElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'Dependency'
                      }
                  }
                }
              },
              template_link: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'templateLink',
                type: {
                  name: 'Composite',
                  class_name: 'TemplateLink'
                }
              },
              parameters: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'parameters',
                type: {
                  name: 'Object'
                }
              },
              parameters_link: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'parametersLink',
                type: {
                  name: 'Composite',
                  class_name: 'ParametersLink'
                }
              },
              mode: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'mode',
                type: {
                  name: 'Enum',
                  module: 'DeploymentMode'
                }
              },
              debug_setting: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'debugSetting',
                type: {
                  name: 'Composite',
                  class_name: 'DebugSetting'
                }
              },
              on_error_deployment: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'onErrorDeployment',
                type: {
                  name: 'Composite',
                  class_name: 'OnErrorDeploymentExtended'
                }
              },
              template_hash: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'templateHash',
                type: {
                  name: 'String'
                }
              },
              output_resources: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'outputResources',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ResourceReferenceElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ResourceReference'
                      }
                  }
                }
              },
              validated_resources: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'validatedResources',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ResourceReferenceElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ResourceReference'
                      }
                  }
                }
              },
              error: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'error',
                type: {
                  name: 'Composite',
                  class_name: 'ErrorResponse'
                }
              }
            }
          }
        }
      end
    end
  end
end
